//---------------------------------------------------------------------------


#pragma hdrstop

#include "SCSICmd.h"
#include <stdio.h>
#pragma package(smart_init)
//---------------------------------------------------------------------------
SCSICmd::SCSICmd() {
    fd=INVALID_HANDLE_VALUE;
}

SCSICmd::~SCSICmd() {
    if (fd!=INVALID_HANDLE_VALUE) CloseHandle (fd);
}

int SCSICmd::associate (char *file) {
    char dev[32];
    sprintf(dev, "\\\\.\\%.*s", sizeof(dev)-5, file);
    fd = CreateFile(
        dev,GENERIC_WRITE|GENERIC_READ,
		FILE_SHARE_READ,NULL,OPEN_EXISTING,0,NULL
    );
	return fd != INVALID_HANDLE_VALUE;
}

unsigned char &SCSICmd::operator[] (size_t i) {
    if (i==0) {
        memset(&p,0,sizeof(p));
	    p.spt.Length = sizeof(p.spt);
	    p.spt.DataIn = SCSI_IOCTL_DATA_UNSPECIFIED;
	    p.spt.TimeOutValue = 30;
	    p.spt.SenseInfoLength = sizeof(p.sense);
	    p.spt.SenseInfoOffset = offsetof(SPKG,sense);
	}
	p.spt.CdbLength = i+1;
	return p.spt.Cdb[i];
}

unsigned char &SCSICmd::sense(size_t i) { return p.sense[i]; }

unsigned char *SCSICmd::sense() { return p.sense; }

void SCSICmd::timeout(int i) { p.spt.TimeOutValue=i; }

int SCSICmd::transport(
    Direction dir, unsigned char *buf, size_t sz
) {
    DWORD bytes;
	p.spt.DataBuffer = buf;
	p.spt.DataTransferLength = sz;
	p.spt.DataIn = dir;
	return DeviceIoControl(
        fd,IOCTL_SCSI_PASS_THROUGH_DIRECT,
		&p,sizeof(p.spt),
		&p,sizeof(p),
		&bytes,FALSE
    ) == 0 || p.sense[0]&0x70;
}

void SCSIDevice::eject(const char *dev, int start_stop) {
    SCSICmd cmd;
    if (cmd.associate((char *) dev)) {
        cmd[0] = SCSI_START_STOP;
        cmd[1] = 1;
        if (start_stop == 1) cmd[4] = 0x02;
        else cmd[4] = 0x03;
        cmd.transport(READ, NULL, 0);
    }
}

const char *venderInfo(const char *dev) {
    //    
}


