//---------------------------------------------------------------------------

#ifndef SCSICmdH
#define SCSICmdH
//---------------------------------------------------------------------------
#include <windows.h>
#include <devioctl.h>
#include <ntddscsi.h>
//---------------------------------------------------------------------------
typedef enum {
    NONE=SCSI_IOCTL_DATA_UNSPECIFIED,
	READ=SCSI_IOCTL_DATA_IN,
	WRITE=SCSI_IOCTL_DATA_OUT
} Direction;

typedef struct {
    SCSI_PASS_THROUGH_DIRECT spt;
    unsigned char sense[18];
} SPKG;

//---------------------------------------------------------------------------
#define TRANSPORT_COMMAND_FAILED    -1
//---------------------------------------------------------------------------
#define SCSI_START_STOP              0x1B    // Start/Stop Unit (O)
//---------------------------------------------------------------------------
class SCSICmd {
private:
    HANDLE  fd;
    SPKG    p;
    int     lerrorno;
public:
    SCSICmd();
    ~SCSICmd();
    int associate(char *file);
    unsigned char &operator[](size_t i);
    unsigned char &sense(size_t i);
    unsigned char *sense();
    void timeout(int i);
    int transport(Direction dir = NONE, unsigned char *buf = NULL, size_t sz = 0);
};
//---------------------------------------------------------------------------
class SCSIDevice {
private :
    SCSICmd cmd;
public :
    SCSIDevice() {};
    ~SCSIDevice() {};
    static void eject(const char *dev, int start_stop);
    static const char* venderInfo(const char *dev);
};
#endif
 