//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "SCSIRunner.h"
#include "FormatMonitor.h"
#include "SCSICmd.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CGAUGES"
#pragma resource "*.dfm"
TMainFrame *MainFrame;
//---------------------------------------------------------------------------
__fastcall TMainFrame::TMainFrame(TComponent* Owner)
    : TForm(Owner)
{
    this->CGauge->Parent = StatBar;
    for(int i=65;i<91;i++) {
        const int result = ::GetDriveType(
            AnsiString(String(char(i))+":\\").c_str()
        );
        if (result != DRIVE_CDROM) continue;
        AnsiString dev = String(char(i))+ ":";
        SCSICmd cmd;
        if (!cmd.associate(dev.c_str())) continue;
        unsigned char dformat[256];
        memset(dformat, 0, sizeof(dformat));
        cmd[0] = 0x12;
        cmd[1] = 0x01;
        cmd[4] = 0xFF;
        if (cmd.transport(READ, dformat, sizeof(dformat))) continue;
        AnsiString desc = "";
        for (int i=8;i<32;i++) desc += String(char(dformat[i]));
        DeviceComboBox->Items->Add(dev + "\\\\<" + desc.Trim() + ">");
    }
    if (DeviceComboBox->Items->Count > 0) DeviceComboBox->ItemIndex = 0;
}
//---------------------------------------------------------------------------

void __fastcall TMainFrame::ShowStatus(const AnsiString &str) {
    this->StatBar->Panels->Items[1]->Text = "  " + str;
}
//---------------------------------------------------------------------------

void __fastcall TMainFrame::SetCGauge(int &prec) {
    this->CGauge->AddProgress(prec);
}
//---------------------------------------------------------------------------

void __fastcall TMainFrame::Button1Click(TObject *Sender)
{
    AnsiString dev = DeviceComboBox->Text;
    dev = dev.SubString(0, dev.Pos(":"));
    SCSIDevice::eject(dev.c_str(), 0);
    FormatMonitor *monitor = new FormatMonitor(true, this);
    monitor->Priority = tpLower;
    monitor->Resume();
}
//---------------------------------------------------------------------------

void __fastcall TMainFrame::StatBarDrawPanel(TStatusBar *StatusBar,
      TStatusPanel *Panel, const TRect &Rect)
{
    this->CGauge->BoundsRect = Rect;
}
//---------------------------------------------------------------------------



